<?php
  header( "Content-Type: text/xml" );
  echo "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
?>
<sql>
<?php
function ReturnSQLError()
{
  return mssql_get_last_message();
}

function RunQuery( $query, $number )
{
  $query = StripSlashes( $query );
  if ( trim( $query ) == '' ) return;
  if ( Substr( $query, 0, 2 ) == '--' ) return;
  
  echo "  <query>\n";
  echo "    <text>$query</text>\n";
  echo "    <result>";
  $rs = @mssql_query( $query );
  if ( $rs ) :
    echo "OK";
  else :
    echo ReturnSQLError();
  endif;
  echo "</result>\n";
  
  if ( $rs ) :
  
      echo "    <set count='" . @mssql_num_rows($rs) . "'>\n";
      while ( $arr = @mssql_fetch_array( $rs ) ) :
        echo "      <row>";
        reset( $arr );
        while ( $field = each( $arr ) ) :
          if ( ! is_int($field[key]) ) :
            echo "<field name='" . $field[key] . "'>".$field[value]. "</field>";
          endif;
        endwhile;
        echo "</row>\n";
      endwhile;
      echo "</set>\n";
      
    echo "    <affected>" . @mssql_rows_affected() . "</affected>\n";
  endif;
  echo "  </query>\n";
}

?>
  <connect><?php
  $conn = @mssql_connect( '', $username, $password );
  if ( $conn ) :
    echo "OK";
  else :
    echo ReturnSQLError();
  endif;
?></connect>
<?php
  if ( $conn )
  {
    if ( isSet( $databases ) )
    {
      echo "  <databases>\n";
      $rs_dbs = @mssql_query('SELECT name FROM master.dbo.sysdatabases');
      if ($rs_dbs)
      {
        while ($dbs = @mssql_fetch_object($rs_dbs))
        {
          echo "    <database>$dbs->name</database>\n";
        }
      }
      echo "  </databases>\n";
    }
    else
    {
?>

  <database name="<?php echo $database ?>"><?php
      $db = @mssql_select_db($database);
      if ( $db )
      {
        echo "OK";
      }
      else
      {
        echo ReturnSQLError();
      }
?></database>

<?php
      if ($db)
      {
        if ( isSet($query) )
        {
          $queries = explode( ';', $query );
          array_walk( $queries, RunQuery );
        }

        if ( isSet($tables) )
        {
          echo "  <tables>\n";
          $rs_tbs = mssql_query( "SELECT dbo.sysobjects.name AS tablename, dbo.sysusers.name AS tableowner
                                    FROM dbo.sysobjects, dbo.sysusers
                                    WHERE dbo.sysobjects.uid = dbo.sysusers.uid AND
                                          dbo.sysobjects.xtype='U'" );
          if ( $rs_tbs )
          {
            while ( $tbs = mssql_fetch_object($rs_tbs))
            {
              echo "    <table>$tbs->tableowner.$tbs->tablename</table>\n";
            }
          }
          echo "  </tables>\n";
        }

        if (isSet($table))
        {
          echo "  <table name=\"$table\">\n";
          $tableinfo = explode( '.', $table);
          $rs = mssql_query(" SELECT dbo.syscolumns.name
                                FROM dbo.syscolumns, dbo.sysusers, dbo.sysobjects
                                WHERE dbo.syscolumns.id = dbo.sysobjects.id AND
                                      dbo.sysobjects.uid = dbo.sysusers.uid AND
                                      dbo.sysobjects.name = '$tableinfo[1]' AND
                                      dbo.sysusers.name = '$tableinfo[0]'");
          if ( $rs )
          {
            while ($rw_fld = mssql_fetch_object($rs))
            {
              echo "    <field>$rw_fld->name</field>\n";
            }
          }
          echo "  </table>\n";
        }
      }
?>

<?php
    } // $database
  } // $conn
?>
</sql>
